//---------------------------------------------------------
//---------------------------------------------------------
//    UAA2022 first test
//---------------------------------------------------------
//---------------------------------------------------------
const int UAA2022_VDR = 2;   //(01) connection to Arduino board: CS
const int UAA2022_CLK = 3;   //(02) connection to Arduino board: Clock
const int UAA2022_DAT = 4;   //(03) connection to Arduino board: Data
//---------------------------------------------------------
//---------------------------------------------------------
void setup()
{
  pinMode(UAA2022_VDR, OUTPUT);   //(04) VDR-Pin shall be output
  pinMode(UAA2022_CLK, OUTPUT);   //(05) Clock-Pin shall be output
  pinMode(UAA2022_DAT, OUTPUT);   //(06) Data-Pin shall be output

  digitalWrite(UAA2022_VDR, 1);  //(07) Set VDR to 1 (inactive)
  digitalWrite(UAA2022_CLK, 1);  //(08) Set Clock to 1
  digitalWrite(UAA2022_DAT, 1);  //(09) Set Data to 1
}
//---------------------------------------------------------
//---------------------------------------------------------
void loop()
{
  int lv_delay = 100;            //(10) wait time between change of the information
  
  UAA2022_send_data(0b00000000, 0b00000000);  //(11) send data to UAA2022
  delay(lv_delay);                            //(12) wait pre-defined time
  UAA2022_send_data(0b10000000, 0b00000001);  //(13) send data to UAA2022
  delay(lv_delay);                            //(14) wait pre-defined time
  UAA2022_send_data(0b11000000, 0b00000011);  //(15) send data to UAA2022
  delay(lv_delay);                            //(16) wait pre-defined time
  UAA2022_send_data(0b11100000, 0b00000111);  //(17) send data to UAA2022
  delay(lv_delay);                            //(18) wait pre-defined time
  UAA2022_send_data(0b11110000, 0b00001111);  //(19) send data to UAA2022
  delay(lv_delay);                            //(20) wait pre-defined time
  UAA2022_send_data(0b11111000, 0b00011111);  //(21) send data to UAA2022
  delay(lv_delay);                            //(22) wait pre-defined time
  UAA2022_send_data(0b11111100, 0b00111111);  //(23) send data to UAA2022
  delay(lv_delay);                            //(24) wait pre-defined time
  UAA2022_send_data(0b11111110, 0b01111111);  //(25) send data to UAA2022
  delay(lv_delay);                            //(26) wait pre-defined time
  UAA2022_send_data(0b11111111, 0b11111111);  //(27) send data to UAA2022
  delay(lv_delay);                            //(28) wait pre-defined time
}

//---------------------------------------------------------
//---------------------------------------------------------
void UAA2022_start()
{
  digitalWrite(UAA2022_VDR, 0);               //(29) activate CS
}
//---------------------------------------------------------
void UAA2022_end()
{
  digitalWrite(UAA2022_VDR, 1);               //(30) de-activate CS
}
//---------------------------------------------------------
void UAA2022_send_bit(byte iv_bit)
{
  if (iv_bit == 0) digitalWrite(UAA2022_DAT, 0);  //(31-1) set Data-Line to 1
  if (iv_bit == 1) digitalWrite(UAA2022_DAT, 1);  //(31-2) set Data-Line to 0

  digitalWrite(UAA2022_CLK, 0);                   //(32-1) generate impuls on CS
  delay(1);                                       //(32-2) generate impuls on CS
  digitalWrite(UAA2022_CLK, 1);                   //(32-3) generate impuls on CS
}
//---------------------------------------------------------
void UAA2022_send_byte(byte iv_byte)
{
  UAA2022_send_bit(bitRead(iv_byte, 0));          //(33-1) send LSb to UAA2022
  UAA2022_send_bit(bitRead(iv_byte, 1));          //(33-2) send nexz bit to the chip
  UAA2022_send_bit(bitRead(iv_byte, 2));          //(33-3) send nexz bit to the chip
  UAA2022_send_bit(bitRead(iv_byte, 3));          //(33-4) send nexz bit to the chip
  UAA2022_send_bit(bitRead(iv_byte, 4));          //(33-5) send nexz bit to the chip
  UAA2022_send_bit(bitRead(iv_byte, 5));          //(33-6) send nexz bit to the chip
  UAA2022_send_bit(bitRead(iv_byte, 6));          //(33-7) send nexz bit to the chip
  UAA2022_send_bit(bitRead(iv_byte, 7));          //(33-8) send MSb to the chip
}
//---------------------------------------------------------
void UAA2022_send_data(byte iv_MSB, byte iv_LSB)
{
  UAA2022_start();                                //(34) start the communication
  UAA2022_send_byte(iv_LSB);                      //(35) send LSB
  UAA2022_send_byte(iv_MSB);                      //(36) send MSB
  UAA2022_end();                                  //(37) end the communication
}
//---------------------------------------------------------
//---------------------------------------------------------
